<?php

namespace App\Http\Middleware;

use App\Providers\RouteServiceProvider;
use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Symfony\Component\HttpFoundation\Response;

class RedirectIfAuthenticated
{
    /**
     * Handle an incoming request.
     *
     * @param  \Closure(\Illuminate\Http\Request): (\Symfony\Component\HttpFoundation\Response)  $next
     */
    public function handle(Request $request, Closure $next, string ...$guards): Response
    {
        $guards = empty($guards) ? [null] : $guards;

        // foreach ($guards as $guard) {
        //     if (Auth::guard($guard)->check()) {
        //         return redirect(RouteServiceProvider::HOME);
        //     }
        // }

        foreach ($guards as $guard) {
            if (Auth::guard($guard)->check() && ! $request->is('register') && ! $request->is('email/verify')) {
                $user = Auth::guard($guard)->user();
    
                switch ($user->user_type) {
                    case 'Cliente':
                        return redirect(RouteServiceProvider::CLIENTE);
                    case 'Tecnicos':
                        return redirect(RouteServiceProvider::TECNICO);
                    case 'inspetor':
                        return redirect(RouteServiceProvider::INSPETOR);
                    // Adicione outros tipos de usuário e suas rotas aqui
                    default:
                        return redirect(RouteServiceProvider::HOME);
                }
            }
        }

        return $next($request);
    }
}
